"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRules = void 0;
const core_1 = require("../core");
const rule_1 = require("../rule");
class JsonRules extends core_1.RuleCore {
    constructor() {
        super();
        this.registerBuiltinRules = () => {
            const mathRules = this.mathRules.getRules();
            const logicalRules = this.logicalRules.getRules();
            const objectRules = this.objectRules.getRules();
            this.registerMany(new Map([...mathRules, ...logicalRules, ...objectRules]));
        };
        this.mathRules = new rule_1.MathRules();
        this.logicalRules = new rule_1.LogicalRules();
        this.objectRules = new rule_1.ObjectRules();
        this.registerBuiltinRules();
    }
}
exports.JsonRules = JsonRules;
//# sourceMappingURL=app.js.map