"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MathRules = void 0;
class MathRules {
    constructor() {
        this.register = () => {
            this.rules.set({ name: 'IsNumber', shortName: 'IsNum' }, this.isNumber);
            this.rules.set({ name: 'Sum', shortName: '+' }, this.sum);
            this.rules.set({ name: 'Subtract', shortName: '-' }, this.subtract);
            this.rules.set({ name: 'Multiply', shortName: '*' }, this.multiply);
            this.rules.set({ name: 'Divide', shortName: '/' }, this.divide);
        };
        this.isNumber = (inputs) => {
            return inputs.every(i => typeof i === 'number');
        };
        this.hasNoZero = (inputs) => {
            return inputs.every(i => i !== 0);
        };
        this.sum = (inputs) => {
            return this.isNumber(inputs) ? inputs.reduce((a, b) => a + b) : 0;
        };
        this.subtract = (inputs) => {
            return this.isNumber(inputs) ? inputs.reduce((a, b) => a - b) : 0;
        };
        this.multiply = (inputs) => {
            return this.isNumber(inputs) ? inputs.reduce((a, b) => a * b) : 0;
        };
        this.divide = (inputs) => {
            return this.isNumber(inputs) && this.hasNoZero(inputs.slice(1)) ? inputs.reduce((a, b) => a / b) : 0;
        };
        this.rules = new Map();
        this.register();
    }
    getRules() {
        return this.rules;
    }
}
exports.MathRules = MathRules;
//# sourceMappingURL=math.js.map